/***************************************************************************
                          cmaprecord.h  -  description
                             -------------------
    begin                : Wed Jan 8 2003
    copyright            : (C) 2003 by Oleksiy Kohany
    email                : kohany@girinst.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CMAPRECORD_H
#define CMAPRECORD_H

#include <string>
#include <iostream>
#include <stdio.h>
#include "constants.h"

using namespace std;

/**
  *@author Oleksiy Kohany
  */

enum CMPBY { TF, TT, QF, QT };
  
class CMapRecord {
public: 
	CMapRecord();
	CMapRecord(const string& tg, unsigned long tf, unsigned long tt, const string& qu, unsigned long qf, unsigned long qt);
	virtual ~CMapRecord();
	friend istream& operator >> (istream& is, CMapRecord& rc);
	friend ostream& operator << (ostream& is, CMapRecord& rc);
  /** Write property of string TGT. */
  virtual void setTGT( const string& _newVal);
  /** Read property of string TGT. */
  virtual const string& getTGT();
  /** Write property of string QU. */
  virtual void setQU( const string& _newVal);
  /** Read property of string QU. */
  virtual const string& getQU();
  /** Write property of unsigned long TGTFrom. */
  virtual void setTGTFrom( const unsigned long& _newVal);
  /** Read property of unsigned long TGTFrom. */
  virtual const unsigned long& getTGTFrom();
  /** Write property of unsigned long TGTTo. */
  virtual void setTGTTo( const unsigned long& _newVal);
  /** Read property of unsigned long TGTTo. */
  virtual const unsigned long& getTGTTo();
  /** Write property of unsigned long QUFrom. */
  virtual void setQUFrom( const unsigned long& _newVal);
  /** Read property of unsigned long QUFrom. */
  virtual const unsigned long& getQUFrom();
  /** Write property of unsigned long QUTo. */
  virtual void setQUTo( const unsigned long& _newVal);
  /** Read property of unsigned long QUTo. */
  virtual const unsigned long& getQUTo();
  /** Write property of CMPBY cmpby. */
  static void setcmpby( const CMPBY& _newVal);
  /** Read property of CMPBY cmpby. */
  static const CMPBY& getcmpby();
  /** No descriptions */
  virtual bool operator > (const CMapRecord& rc) const;
  /** No descriptions */
  virtual bool operator < (const CMapRecord& rc) const;
  /** No descriptions */
  virtual bool operator == (const CMapRecord& rc) const;
  /** No descriptions */
  void assign(const string& tg, unsigned long tf, unsigned long tt, const string& qu, unsigned long qf, unsigned long qt);
  /** No descriptions */
  void print(FILE *os) const;
  /** No descriptions */
  void print(ostream* os) const;
  /** No descriptions */
  int read(istream* is);
  /** No descriptions */
  int read(FILE *is);
protected: // Private attributes
  /**  */
  string TGT;
  /**  */
  unsigned long TGTTo;
  /**  */
  unsigned long QUFrom;
  /**  */
  unsigned long QUTo;
  /**  */
  string QU;
  /**  */
  unsigned long TGTFrom;
  /**  */
  static CMPBY cmpby;
private: // Private methods
  /** No descriptions */
  virtual unsigned long getCmpVal() const;
};
#endif

istream& operator >> (istream& is, CMapRecord& mr);
ostream& operator << (ostream& is, CMapRecord& mr);

